package lab2;

import java.sql.*;

public class EntradaSistemaDB implements InterfaceLogicaNegocio {
  PreparedStatement s;
  Connection c;
  Statement st; 
  PropiedadesDelSistema prop;
  
  public EntradaSistemaDB()   {
    try {
    prop = new PropiedadesDelSistema();
    System.out.println(prop.getSO());
    System.out.println(prop.getDB());
    if (prop.getSO().equals("Windows")) {
        if (prop.getDB().equals("ACCESS")) {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            c = DriverManager.getConnection("jdbc:odbc:BDPasswLabLog3N"); 
        } else if (prop.getDB().equals("ORACLE")) {
            Class.forName("oracle.jdbc.driver.OracleDriver");
            c =  DriverManager.getConnection("jdbc:oracle:thin:@g010128.si.ehu.es:1521:ISO","ISO","ISO");
        } else if (prop.getDB().equals("MYSQL")) {
            Class.forName("com.mysql.jdbc.Driver");
            c =  DriverManager.getConnection("jdbc:mysql://jipla0.si.ehu.es/ISO","ISO","ISO");
        }
      }
      if (prop.getDB().equals("ORACLE"))  s =  c.prepareStatement("select * from jimena.cuenta where usuario=? and password=?");
      else  s =  c.prepareStatement("select * from cuenta where usuario=? and password=?");
      st = c.createStatement(); 
   } catch (ClassNotFoundException e) { System.out.println("Clase no encontrada");  
   } catch (Exception ex) {  ex.printStackTrace(); }   
    
  }
  public boolean hacerLogin(String u, String p) {
   try {
      s.setString(1,u);
      s.setString(2,p);
      ResultSet r=s.executeQuery();
      boolean res = r.next(); 
      if (res) { 
        if (prop.getDB().equals("ORACLE")) st.executeUpdate("update jimena.cuenta set numIntentosFallidos=0 where usuario='"+u+"'");
        else st.executeUpdate("update cuenta set numIntentosFallidos=0 where usuario='"+u+"'");
      } else {
         if (prop.getDB().equals("ORACLE"))  st.executeUpdate("update jimena.cuenta set numIntentosFallidos=numIntentosFallidos+1 where usuario='"+u+"'");
         else st.executeUpdate("update cuenta set numIntentosFallidos=numIntentosFallidos+1 where usuario='"+u+"'");
      }
      return res;
   } catch (SQLException e) {System.out.println("Error en el SQL: "+e.toString()); return false;
   } catch (Exception ex) {System.out.println("Error: "); ex.printStackTrace(); return false;}
  }
  public void cerrarConexion()  {
    try   {
        c.close();
    } catch (SQLException e)   {    e.printStackTrace();  
    } catch (Exception ex)   {    ex.printStackTrace();  }
  }
  
}
